PROGRAM demo;

USES VGA, MFTIMER, CRT;

TYPE StarRecord = RECORD
                    X, Y : LONGINT;
                  END;

VAR Stars      : ARRAY[0..199] OF StarRecord; (* positions of points        *)

(****************************************************************************)
(* This one fills the destination with a smooth circled pattern.            *)
(****************************************************************************)
  PROCEDURE Effect1(Too : DWORD);
  VAR W1, W2 : WORD;
  BEGIN
    FOR W1 := 0 TO 319 DO BEGIN
      PutPixel(Too,0,W1,0); PutPixel(Too,199,W1,0);
    END;
    FOR W1 := 1 TO 198 DO
     FOR W2 := 1 TO 318 DO
      PutPixel(Too,W1,W2,
      trunc( sin((SQRT(SQR(W1-100)+SQR(W2-160))/25*3.1415)) * 255 ));
  END;

(****************************************************************************)
(* This one draws randomly moving dots.                                     *)
(****************************************************************************)
  PROCEDURE Effect2(Too : DWORD);
  VAR W1 : LONGINT;
  BEGIN
    FOR W1 := 0 TO 49 DO BEGIN
      INC(STARS[W1].Y, 2-random(5));
      IF (Stars[W1].Y > 319) THEN Stars[W1].Y := 0
         ELSE IF (Stars[W1].Y < 0) THEN Stars[W1].Y := 319;
      INC(STARS[W1].X, 2-random(5));
      IF (Stars[W1].X > 199) THEN Stars[W1].X := 0
         ELSE IF (Stars[W1].X < 0) THEN Stars[W1].X := 198;
    END;
    FOR W1 := 0 TO 49 DO BEGIN
      PutPixel(Too, Stars[W1].X, STars[W1].Y, 255);
      PutPixel(Too, Stars[W1].X+1, STars[W1].Y, 255);
      PutPixel(Too, Stars[W1].X, STars[W1].Y+1, 255);
      PutPixel(Too, Stars[W1].X+1, STars[W1].Y+1, 255);
    END;
  END;

(****************************************************************************)
(* This one draws randomly moving NrOfLines interconnected lines.           *)
(****************************************************************************)
  PROCEDURE Effect3(Too, NrOfLines : DWORD);
  VAR W1 : LONGINT;
  BEGIN
    FOR W1 := 0 TO NrOfLines DO
      Line(Too, Stars[W1].X, Stars[W1].Y,
                  Stars[W1+1].X, Stars[W1+1].Y, 255);

    Line(Too, Stars[0].X, Stars[0].Y, Stars[W1+1].X, Stars[W1+1].Y, 255);
    FOR W1 := 0 TO 49 DO BEGIN
      INC(STARS[W1].Y, 8-random(17));
      IF (Stars[W1].Y > 319) THEN Stars[W1].Y := 319
         ELSE IF (Stars[W1].Y < 0) THEN Stars[W1].Y := 0;
      INC(STARS[W1].X, 8-random(17));
      IF (Stars[W1].X > 198) THEN Stars[W1].X := 198
         ELSE IF (Stars[W1].X < 1) THEN Stars[W1].X := 1;
    END;
  END;

(****************************************************************************)
(* Init's the positions of the array used by effect2 & effect3              *)
(****************************************************************************)
  PROCEDURE InitStars;
  VAR W1 : LONGINT;
  BEGIN
    FOR W1 := 0 TO 199 DO BEGIN
      Stars[W1].X := 1 + random(198);
      Stars[W1].Y := Random(320);
    END;
  END;

(****************************************************************************)
(* The main program :)                                                      *)
(****************************************************************************)
VAR P1, P2, P3, P4, P5, P6, P7, P8, P9, PA, PB : DWORD;   (* Deez zijn allemaal fake screens *)
    W1, W2, W3, W4, W5, W6, W7 : LONGINT; (* wa tijdelijke variabelen        *)
    T1, T2, T3, T4, T5 : LONGINT; (* timers                          *)
    countkey  : byte;
BEGIN
  (** Allocate some 'pages' : 320*200*8 bit ... **)
  P1 := NewPage;
  P2 := NewPage;
  P3 := NewPAge;
  P4 := NewPAge;
  P5 := NewPage;
  P6 := NewPage;
  P7 := NewPage;
  P8 := NewPage;
  P9 := NewPage;
  PA := NewPage;
  PB := NewPage;


  (** Load a raw image in P3, notice that the bumpmapping and some other **)
  (** procedures (rotate) expect a 256*256 instead of 320*200. This image **)
  (** is 256*256, and used as ... well, you'll see :)                     **)
  LoadRaw(P3, 'Mute.Raw');

  SetMode($13);                      (* Switch screen mode to VGA           *)

  SetColorFade(0,128,0,0,0,0,80,255);
  SetColorFade(128,255,0,80,255,255,210,255);

(****************************************************************************)
  Effect1(P1);

  WHILE KeyPressed DO ReadKey;       (* Clear keyboard buffer.              *)
  REPEAT

    (** Smudge out the screen **)
    CopyPageSmudge(P1, $A0000);
    CopyPage($A0000, P1);

  UNTIL KeyPressed; ReadKey;         (* Wait for key and get it from buffer *)


(****************************************************************************)
  InitStars;

  (** Use the last destination as a new source. This makes the effects **)
  (** flow into each other                                             **)

  CopyPage(P1, P2);

  REPEAT
    Effect2(P2);
    CopyPageSmudge(P2, $A0000);
    CopyPage($A0000, P2);
  UNTIL KeyPRessed; ReadKey;

(****************************************************************************)

  W3 := 2;
  W2 := 0;
  REPEAT
    INC(W2);
    IF (W2 = 200) THEN BEGIN
      IF W3 < 40 THEN INC(W3);
      W2 := 0;
    END;

    Effect3(P2,W3);

    CopyPageSmudge2(P2, $A0000);
    CopyPage($A0000, P2);
  UNTIL KeyPRessed; ReadKey;

(****************************************************************************)
  ClearPage(P1);
  ClearPage(P5);
  ClearPage(P4);

  W1 := 0;
  W2 := 0;
  W3 := 0;

  T1 := 0;     (* The timer. *)
  T2 := 196;    (* The value to add to the timer *)
  NewTimer(T1,T2); (* From now on t2 is repeatedly added to T1 *)
  REPEAT
   W1 := T1 SHR 8; (* fixed point trick :) *)
   W2 := TRUNC(SIN(W1/250*3.1415)*64);
   RotateT(P3,P2,W1,32768,32768,128+W2);
   CopyPageSmudge2(P2, $A0000);
   CopyPage($A0000, P2);
  UNTIL KeyPressed; ReadKey;


(****************************************************************************)
  W1 := 0;
  W2 := 0;
  W3 := 0;
  T1 := 0;    (* We change the timer's values *)
  T2 := 100;  (* no need to allocate a new timer, it's still runnig... *)
  REPEAT
   W1 := T1 SHR 8;
   W2 := 196 + TRUNC(SIN(W1/250*3.1415)*256);
   RotateT(P3,P2,W1,32768+(W1 SHL 4),32768-(W1 SHL 6),128+W2);
   CopyPageSmudge2(P2, P5);
   CopyPage(P5, P2);

   Effect2(P1);
   CopyPageSmudge(P1,P4);
   CopyPage(P4,P1);

   MixPages2(P4,P5,$A0000);

  UNTIL KeyPressed; ReadKey;


(****************************************************************************)
  ClearPage(P5);
  ClearPage(P4);
  CopyPage($A0000,P2);
  CopyPage($A0000,P1);
  W1 := 0;
  W2 := 0;
  W3 := 0;
  T1 := 0;
  T2 := 60;
  T3 := 0;
  T4 := 100;
  NewTimer(T3,T4);
  countkey := 1;
  initbump(p8);
  clearpage(p9);
  clearpage(pA);
  clearpage(pB);
  REPEAT
   W1 := T1 SHR 8;
   W3 := T3 SHR 8;
   W2 := 196 + TRUNC(SIN(W1/250*3.1415)*256);
   W4 := 196 + TRUNC(SIN((W3+100)/300*3.1415)*256);
   W5 := 128 + TRUNC(SIN(W1/200*3.1415)*127);

   RotateTW(P3,P2,W1,32768+(W1 SHL 4),32768-(W1 SHL 6),128+W2,2,2);
   CopyPageSmudge2(P2, P5);
   CopyPage(P5, P2);

   RotateTW(P3,P1,-W3,32768+(W3 SHL 6),32768-(W3 SHL 3),128+W4,4,4);
   CopyPageSmudge2(P1,P4);
   CopyPage(P4,P1);

   IF countkey < 2 THEN BEGIN
     MixPages3(P4,P5,$A0000,64 + (W5 SHR 1));
     W6 := 0;
     W7 := 255;
   end else IF countkey < 3 THEN BEGIN
     MixPages3(P4,P5,P7,64 + (W5 SHR 1));

     BumpMap3(P7, P6, P8, (-140)+W5, (-100)+w4 div 2);

     IF (W6 = 0) AND (W7 > (32+(W5 SHR 2))) THEN BEGIN
       DEC(W7,4);
       IF (W7 < (32+(W5 SHR 2))) THEN W6 := 1;
     END ELSE W7 := (32+(W5 SHR 2));

     MixPages3(P7, P6, $A0000, w7 {32 + (W5 SHR 2)});
   END ELSE BEGIN
     MixPages3(P4,P5,P7,64 + (W5 SHR 1));

     Effect2(P9);
     CopyPageSmudge2(P9, PB);
     CopyPage(PB, P9);

     MixPages2(P7, P9, PA);

     BumpMap3(PA, P6, P8, (-140)+W5, (-100)+w4 div 2);

     W7 := (32+(W5 SHR 2));

     MixPages3(P7, P6, $A0000, w7 {32 + (W5 SHR 2)});

   END;
   if keypressed then begin
     while keypressed do readkey;
     inc(countkey);
   end;
  UNTIL CountKey = 4;
(****************************************************************************)
  CopyPage($A0000, P1);
  FOR W1 := 0 TO 50 DO BEGIN
    CopyPageSmudge2(P1, $A0000);
    CopyPage($A0000, P1);
  END;
(****************************************************************************)
  DisposePAge(P1);
  DisposePage(P2);
  DisposePage(P3);
  DisposePage(P4);
  DisposePage(P5);

  SetMode($3);                       (* Switch screenmode back to text.     *)

  Writeln ('Written by enki !');
  WriteLn;
  WriteLn ('www.mutefantasies.com');
END.